/* project.h
*/	

/*
 * General typedefs
 */
#include <windows.h>
#include <gl/gl.h>

#ifndef PROJECT_H
#define PROJECT_H 1

#define PI						3.1415926
#define DEGTORAD				0.01745329

typedef float	vect3_t[3];
typedef float	vect2_t[2];
typedef unsigned long int long3_t[3];
typedef unsigned long int long2_t[2];
typedef unsigned short int short3_t[3];
typedef unsigned short int short2_t[2];

typedef struct {
	vect3_t pos;
	vect3_t rot;
	float zoom;

	vect3_t old_pos;
	vect3_t old_rot;
	vect3_t new_pos;
	vect3_t new_rot;

	vect3_t lightdir;

	double oldtime;
	double newtime;
	double time;
} viewport_t;


#define MODE_NORMAL		0
#define MODE_INTERACT	1
#define MODE_BENCHSING	2
#define MODE_BENCHALL	3

typedef struct {
	float benchLast;
	float benchComp[20];
	HWND hWnd;
	HWND hGLWnd;
	HWND hMenuWnd;
	HGLRC glRC;
	HDC  hglDC;
	int mode;
	int glwidth;
	int glheight;
	int winwidth;
	int winheight;

	// basic config
	int numplants;
	float terrainscale;
	unsigned int briver;
	int rseed;
	float fscale;
	int initfreq;
	float fyscale;
	int numpass;
	int rendermode;
	int twod;

} global_t;

#endif