

#ifndef TERRAIN_H
#define TERRAIN_H

// basis matrix for spline interpolation
#define CR00	-0.5
#define CR01	1.5
#define CR02	-1.5
#define CR03	0.5
#define CR10	1.0
#define CR11	-2.5
#define CR12	2.0
#define CR13	-0.5
#define CR20	-0.5
#define CR21	0.0
#define CR22	0.5
#define CR23	0.0
#define CR30	0.0
#define CR31	1.0
#define CR32	0.0
#define CR33	0.0

// terrain structure
typedef struct {
	int seed;
	int numpass;
	float scale;
	float fyscale;
	float freqscale;
	float initfreq;
	int xres, zres;
	float xscale, zscale;
	float miny, maxy;

	// data
	float *hbuffer, *wbuffer;

	// render data
	float *vlist, *nlist, *clist, *tlist;
	int listcnt;
	unsigned short *elements;
	double numelem;
} terrain_t;

// terrain functions
void initTerrain( terrain_t *ter, int xres, int zres, float xscale, float zscale, float scale );
void freeTerrain( terrain_t *ter );

void createTerrain( terrain_t *ter, int seed, float fyscale, float freqscale, float initfreq, int numpass, int river, int twod );
void fracSynthPass( float *buf, float freq, float zscale, int xres, int zres );
void generateRiver( float *hbuf, float *wbuf, int xres, int zres,  float pt1[2], float pt2[2], float complexity );

void drawTerrainPoint( terrain_t *ter );
void drawTerrainPoly( terrain_t *ter );

#endif